import { Dependency, TaskDep } from './task';
import { TaskContext } from './task-manager';
export declare class DepBuilder<O = any> {
    private _dep;
    readonly _isDepBuilder = true;
    constructor(name: Dependency);
    /**
     *
     * Dependences are executed serially by default.
     * If order doesn't matter and you want better performance via parallel, you can mark it as asynchronized.
     * Asynchronized will run immediately whether there are synchronized tasks before them or not.
     * You can pass a number as the priority of asynchronized tasks, bigger is formmer.
     * @param priority
     */
    async(priority?: number | boolean): this;
    force(): this;
    options(opts: O | ((ctx: TaskContext) => O)): this;
    toTaskDep(): TaskDep<O>;
}
export declare function dep(dep: Dependency): DepBuilder<any>;
declare global {
    interface String {
        /**
         * Dependences are executed serially by default.
         * If order doesn't matter and you want better performance via parallel, you can mark it as asynchronized.
         * Asynchronized will run immediately whether there are synchronized tasks before them or not.
         * You can pass a number as the priority of asynchronized tasks, bigger is formmer.
         */
        async(priority?: number | boolean): DepBuilder;
        force(): DepBuilder;
        options<O>(opts: O | NonNullable<TaskDep['resolveOptions']>): DepBuilder;
    }
}
